//
// Copyright (c) 1994-1996, David McFadzean
//
// You may distribute under the terms of the Artistic License, 
// as specified in the README file.
//
// $Header: E:/simbiosys/RCS/GTYPE.H 1.1 1996/06/26 10:55:14 dbm Exp $
//
    
#ifndef GTYPE_H
#define GTYPE_H
                
#include "simbio.h"
                
/////////////////////////////////////////////////////////////////////////////
//
//	bioGType
//

class bioGType : public bioObject
{
  public:
  	ctor				bioGType (void) {}
  	dtor				~bioGType (void) {}
  	
  	virtual void		SetLength (int) = 0;
  	virtual int			GetLength (void) = 0;
  	
  	virtual void		Randomize (void) = 0;
  	virtual void		Mutate (double rate) = 0;
  	virtual bioGType*	Crossover (bioGType*) = 0; 
  	
  	   
  protected:
}; 

/////////////////////////////////////////////////////////////////////////////
//
//	bioHapGType
//
   
class bioHapGType : public bioGType
{ 
  public:
  	ctor				bioHapGType (void);
  	ctor				bioHapGType (bioHapGType&);
  	dtor				~bioHapGType (void);
  	
  	bioHapGType&        operator= (const bioHapGType& rhs);
  	
  	override void		SetLength (int);
  	override int		GetLength (void);
  	
  	override void		Randomize (void);
  	override void		Mutate (double rate);
  	override bioGType*	Crossover (bioGType*);
  	
  	virtual char		GetByte (int idx);				
  	virtual int			GetBit (int idx);				
  	
  	virtual void		SetBit (int idx, int on = 1);
  	virtual void		ResetBit (int idx);
  	virtual void		ToggleBit (int idx);
  	    
  protected:
	int					_bits;		// bit count
	int					_bytes;		// string length            
	char*				_dna;       // bit string
};

#endif // GTYPE_H
